import os
from ast import literal_eval
from .PinnacleErrors import ExtensionError


__author__ = "Chtaïba Omar"
__version__ = "Beta"
__email__ = "omarchtaiba4@gmail.com"
__github__ = "https://github.com/Omar1CHTAIBA"
__X__ = "https://x.com/OmarChtaib90132"


class PicleSerializer:

    @staticmethod
    def serialize(obj, filename):
        """Serialize a dictionary to a .pdb file."""
        if not isinstance(obj, dict):
            raise ValueError("Only dictionaries can be serialized.")

        # Ensure the file extension is .pdb
        if not filename.endswith('.pdb'):
            raise ExtensionError("The filename must end with a .pdb extension.")

        serialized_str = str(obj)
        serialized_bytes = serialized_str.encode('utf-8')

        with open(filename, 'wb') as file:
            file.write(serialized_bytes)


    @staticmethod
    def deserialize(filename):
        """Deserialize a dictionary from a .pdb file."""
        if not filename.endswith('.pdb'):
            raise ExtensionError("The filename must end with a .pdb extension.")

        if not os.path.exists(filename):
            raise FileNotFoundError(f"{filename} not found.")

        with open(filename, 'rb') as file:
            serialized_bytes = file.read()

        serialized_str = serialized_bytes.decode('utf-8')
        deserialized_dict = literal_eval(serialized_str)
        return deserialized_dict